
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <stdbool.h>
#include <ctype.h>

#include "../../augh/indent.h"
#include "../../augh/auto/auto.h"
#include "../../augh/auto/techno.h"
#include "../../augh/netlist/netlist.h"
#include "../../augh/netlist/netlist_comps.h"
#include "../../augh/netlist/netlist_access.h"
#include "../../augh/plugins/plugins_techno.h"

#include "xilinx_techno.h"
#include "xilinx_xst.h"
#include "xilinx_vivado.h"



//======================================================================
// Extra data for FPGAs of boards
//======================================================================

xilinx_board_data_t* Xilinx_BoardData_New() {
	xilinx_board_data_t* data = calloc(1, sizeof(*data));
	data->cfgbvs_en = false;
	return data;
}


//======================================================================
// Board descriptions
//======================================================================

board_t* Xilinx_BuildBoard_Xupv5() {
	board_t* board = Board_New();

	board->name = namealloc("xupv5");
	board->description = stralloc("XUPV5 evaluation board. The FPGA is xc5vlx110t, speed grade 1, package ff1136.");

	// Add a board_fpga_t structure
	board_fpga_t* board_fpga = Board_FPGA_New();
	board_fpga->name = namealloc("fpga");
	board_fpga->model = Techno_GetFPGA(namealloc("xc5vlx110t"));
	assert(board_fpga->model!=NULL);
	board_fpga->speed = Techno_FPGA_GetSpeed(board_fpga->model, namealloc("1"));
	assert(board_fpga->speed!=NULL);
	board_fpga->package = Techno_FPGA_GetPkg(board_fpga->model, namealloc("ff1136"));
	assert(board_fpga->package!=NULL);

	board_fpga->board = board;
	avl_pp_add_overwrite(&board->fpgas, board_fpga->name, board_fpga);

	// The JTAG id
	board_fpga->jtag_id = 5;
	board_fpga->xc3sprog_cable = stralloc("xpc");

	// Add board connectivity

	netlist_comp_t* comp = board_fpga->connect = Netlist_Comp_Top_New(board_fpga->name);
	chain_list* pinsattr;

	// The 100 MHz clock USER_CLOCK (part X1 on the board)

	netlist_port_t* port_clk100m = Netlist_Comp_AddPortAccess_Clock(comp, namealloc("xupv5_clock100"));
	Netlist_Access_Clock_SetFrequency(port_clk100m->access, 100e6);
	// Set as default for the FPGA
	board_fpga->default_clock = port_clk100m->access;

	pinsattr = ListPin_MakeListAttr("LOC = AH15", "IOSTANDARD = LVCMOS33", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_clk100m, pinsattr);

	#if 0  // FIXME: These inputs don't seem to be turned on

	// The 33 MHz clock (generated by part U8 on the board)

	netlist_port_t* port_clk33m = Netlist_Comp_AddPortAccess_Clock(comp, namealloc("xupv5_clock33"));
	Netlist_Access_Clock_SetFrequency(port_clk33m->access, 33e6);

	// FIXME not sure about the LVCMOS33
	pinsattr = ListPin_MakeListAttr("LOC = AH17", "IOSTANDARD = LVCMOS33", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_clk33m, pinsattr);

	// The 27 MHz clock (generated by part U8 on the board)

	netlist_port_t* port_clk27m = Netlist_Comp_AddPortAccess_Clock(comp, namealloc("xupv5_clock27"));
	Netlist_Access_Clock_SetFrequency(port_clk27m->access, 27e6);

	// FIXME not sure about the LVCMOS33
	pinsattr = ListPin_MakeListAttr("LOC = AG18", "IOSTANDARD = LVCMOS33", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_clk27m, pinsattr);

	#endif

	// The CPU_RESET button (part SW7 on the board)

	netlist_port_t* port_cpureset = Netlist_Comp_AddPortAccess_Reset(comp, namealloc("xupv5_cpureset"));
	Netlist_Access_Reset_SetActiveState(port_cpureset->access, '0');
	// Set as default for the FPGA
	board_fpga->default_reset = port_cpureset->access;

	pinsattr = ListPin_MakeListAttr("LOC = E9", "IOSTANDARD = LVCMOS33", "TIG", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_cpureset, pinsattr);

	#if 1  // New code, separate Rx and Tx ports

	// The UART 1 interface

	// Rx
	netlist_access_t* access_uart1rx = Netlist_Comp_AddAccess_Uart_Rx(comp, namealloc("xupv5_uart1_rx"));
	netlist_access_uart_side_t* access_uart1rx_data = access_uart1rx->data;
	access_uart1rx_data->cfg.databits_nb = 8;
	access_uart1rx_data->cfg.baudrate = 115200;
	access_uart1rx_data->cfg.parity = false;
	// Set as default communication channel
	board_fpga->default_stdin = access_uart1rx;

	pinsattr = ListPin_MakeListAttr("LOC = AG15", "IOSTANDARD = LVCMOS33", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_uart1rx_data->port_uart, pinsattr);

	// Tx
	netlist_access_t* access_uart1tx = Netlist_Comp_AddAccess_Uart_Tx(comp, namealloc("xupv5_uart1_tx"));
	netlist_access_uart_side_t* access_uart1tx_data = access_uart1tx->data;
	access_uart1tx_data->cfg.databits_nb = 8;
	access_uart1tx_data->cfg.baudrate = 115200;
	access_uart1tx_data->cfg.parity = false;
	// Set as default communication channel
	board_fpga->default_stdout = access_uart1tx;

	pinsattr = ListPin_MakeListAttr("LOC = AG20", "IOSTANDARD = LVCMOS33", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_uart1tx_data->port_uart, pinsattr);

	// The UART 2 interface

	// Rx
	netlist_access_t* access_uart2rx = Netlist_Comp_AddAccess_Uart_Rx(comp, namealloc("xupv5_uart2_rx"));
	netlist_access_uart_side_t* access_uart2rx_data = access_uart2rx->data;
	access_uart2rx_data->cfg.databits_nb = 8;
	access_uart2rx_data->cfg.baudrate = 115200;
	access_uart2rx_data->cfg.parity = false;

	pinsattr = ListPin_MakeListAttr("LOC = G10", "IOSTANDARD = LVCMOS33", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_uart2rx_data->port_uart, pinsattr);

	// Tx
	netlist_access_t* access_uart2tx = Netlist_Comp_AddAccess_Uart_Tx(comp, namealloc("xupv5_uart2_tx"));
	netlist_access_uart_side_t* access_uart2tx_data = access_uart2tx->data;
	access_uart2tx_data->cfg.databits_nb = 8;
	access_uart2tx_data->cfg.baudrate = 115200;
	access_uart2tx_data->cfg.parity = false;

	pinsattr = ListPin_MakeListAttr("LOC = F10", "IOSTANDARD = LVCMOS33", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_uart2tx_data->port_uart, pinsattr);

	#endif

	#if 0  // Old code

	// The UART 1 interface

	netlist_access_t* access_uart1 = Netlist_Comp_AddAccess_Uart(comp, namealloc("xupv5_uart1"));
	netlist_uart_access_t* access_uart1_data = access_uart1->data;
	access_uart1_data->bits_nb = 8;
	access_uart1_data->baudrate = 115200;
	access_uart1_data->parity = false;

	pinsattr = ListPin_MakeListAttr("LOC = AG20", "IOSTANDARD = LVCMOS33", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_uart1_data->port_tx, pinsattr);

	pinsattr = ListPin_MakeListAttr("LOC = AG15", "IOSTANDARD = LVCMOS33", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_uart1_data->port_rx, pinsattr);

	// The UART 2 interface

	netlist_access_t* access_uart2 = Netlist_Comp_AddAccess_Uart(comp, namealloc("xupv5_uart2"));
	netlist_uart_access_t* access_uart2_data = access_uart2->data;
	Netlist_Access_Uart_SetBaudrate(access_uart2, 115200);

	pinsattr = ListPin_MakeListAttr("LOC = F10", "IOSTANDARD = LVCMOS33", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_uart2_data->port_tx, pinsattr);

	pinsattr = ListPin_MakeListAttr("LOC = G10", "IOSTANDARD = LVCMOS33", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_uart2_data->port_rx, pinsattr);

	#endif

	// The GPIO DIP Switches (note: active high)

	netlist_port_t* port_dipsw = Netlist_Comp_AddPortAccess_WireIn(comp, namealloc("xupv5_dipsw"), 8);

	// DIP Switches: here processed from 1 to 8
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = U25",  "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AG27", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AF25", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AF26", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AE27", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AE26", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AC25", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AC24", "IOSTANDARD = LVCMOS18", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_dipsw, reverse(pinsattr));

	// The LEDs 8 bits (note: active high)

	netlist_port_t* port_leds8 = Netlist_Comp_AddPortAccess_WireOut(comp, namealloc("xupv5_leds8"), 8);

	// LEDs: here processed from 7 downto 0
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AE24", "IOSTANDARD = LVCMOS18", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AD24", "IOSTANDARD = LVCMOS18", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AD25", "IOSTANDARD = LVCMOS18", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = G16",  "IOSTANDARD = LVCMOS25", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AD26", "IOSTANDARD = LVCMOS18", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = G15",  "IOSTANDARD = LVCMOS25", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = L18",  "IOSTANDARD = LVCMOS25", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = H18",  "IOSTANDARD = LVCMOS25", "SLEW = SLOW", "DRIVE = 2", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_leds8, pinsattr);

	// The LEDs position south, north etc (note: active high)

	netlist_port_t* port_ledspos = Netlist_Comp_AddPortAccess_WireOut(comp, namealloc("xupv5_ledspos"), 5);

	// Here processed in this order: north, east, south, west, center
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AF13", "IOSTANDARD = LVCMOS33", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AG23", "IOSTANDARD = LVCMOS33", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AG12", "IOSTANDARD = LVCMOS33", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AF23", "IOSTANDARD = LVCMOS33", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = E8",   "IOSTANDARD = LVCMOS33", "SLEW = SLOW", "DRIVE = 2", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_ledspos, pinsattr);

	// The LED Error 1 (note: active high)

	netlist_port_t* port_lederr1 = Netlist_Comp_AddPortAccess_WireOut(comp, namealloc("xupv5_lederr1"), 1);
	pinsattr = ListPin_MakeListAttr("LOC = F6", "IOSTANDARD = LVCMOS33", "TIG", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_lederr1, pinsattr);

	// The LED Error 2 (note: active high)

	netlist_port_t* port_lederr2 = Netlist_Comp_AddPortAccess_WireOut(comp, namealloc("xupv5_lederr2"), 1);
	pinsattr = ListPin_MakeListAttr("LOC = T10", "IOSTANDARD = LVCMOS33", "TIG", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_lederr2, pinsattr);

	// The Switches position south, north etc (note: active high)

	netlist_port_t* port_swpos = Netlist_Comp_AddPortAccess_WireIn(comp, namealloc("xupv5_swpos"), 5);

	// Here processed in this order: north, east, south, west, center
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = U8",  "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AK7", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = V8",  "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AJ7", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AJ6", "IOSTANDARD = LVCMOS33", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_swpos, pinsattr);

	// The Piezzo speaker

	netlist_port_t* port_piezzo = Netlist_Comp_AddPortAccess_WireOut(comp, namealloc("xupv5_piezzo"), 1);
	pinsattr = ListPin_MakeListAttr("LOC = G30", "IOSTANDARD = LVCMOS18", "TIG", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_piezzo, pinsattr);

	// The rotary encoder (note: active high)
	// Chip: Panasonic EVQWK4001
	// Note: 15 pulses per revolution
	// Note: clockwise rotation: AB: 00 -> 01 -> 11 -> 10

	netlist_port_t* port_rotary = Netlist_Comp_AddPortAccess_WireIn(comp, namealloc("xupv5_rotary"), 3);

	// Here processed in order: INCA, INCB, PUSH
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AH30", "IOSTANDARD = LVCMOS18", "TIG", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AG30", "IOSTANDARD = LVCMOS18", "TIG", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AH29", "IOSTANDARD = LVCMOS18", "TIG", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_rotary, pinsattr);

	/* Missing board features (from UG347)

	- ZBT synchronous SRAM (chip: ISSI IS61NLP25636A-200TQL)
	  The memory is organized as 256K x 36 bits.
	  This organization provides for a 32-bit data bus with support for four parity bits.

	- LCD 2x16 (module: Tianma TM162VBA6)
	  Pin E:   LOC = AC9;  IOSTANDARD=LVCMOS33; TIG; PULLDOWN;
	  Pin RS:  LOC = J17;  IOSTANDARD=LVCMOS25; TIG; PULLDOWN;
	  Pin RW:  LOC = AC10; IOSTANDARD=LVCMOS33; TIG; PULLDOWN;
	  Pin DB7: LOC = T11;  IOSTANDARD=LVCMOS33; TIG; PULLDOWN;
	  Pin DB6: LOC = G6;   IOSTANDARD=LVCMOS33; TIG; PULLDOWN;
	  Pin DB5: LOC = G7;   IOSTANDARD=LVCMOS33; TIG; PULLDOWN;
	  Pin DB4: LOC = T9;   IOSTANDARD=LVCMOS33; TIG; PULLDOWN;

	- VGA
	- USB, Ethernet, PCI-Express
	- I2C, SPI

	*/

	// Finally, return the board
	return board;
}

board_t* Xilinx_BuildBoard_Zybo() {
	board_t* board = Board_New();

	board->name = namealloc("zybo");
	board->description = stralloc("ZYBO Zynq-7000 development board. The FPGA is xc7z010 speed grade 1 (techno artix-7).");

	// Add a board_fpga_t structure
	board_fpga_t* board_fpga = Board_FPGA_New();
	board_fpga->name = namealloc("fpga");
	board_fpga->model = Techno_GetFPGA(namealloc("xc7z010"));
	assert(board_fpga->model!=NULL);
	board_fpga->speed = Techno_FPGA_GetSpeed(board_fpga->model, namealloc("1"));
	assert(board_fpga->speed!=NULL);
	board_fpga->package = Techno_FPGA_GetPkg(board_fpga->model, namealloc("clg400"));
	assert(board_fpga->package!=NULL);

	board_fpga->board = board;
	avl_pp_add_overwrite(&board->fpgas, board_fpga->name, board_fpga);

	// The JTAG id
	board_fpga->jtag_id = 2;
	board_fpga->xc3sprog_cable = stralloc("jtaghs1");

	// Add board connectivity

	netlist_comp_t* comp = board_fpga->connect = Netlist_Comp_Top_New(board_fpga->name);
	chain_list* pinsattr;

	// The 125 MHz clock USER_CLOCK (on the board)

	netlist_port_t* port_clk125m = Netlist_Comp_AddPortAccess_Clock(comp, namealloc("zybo_clock125"));
	Netlist_Access_Clock_SetFrequency(port_clk125m->access, 125e6);
	// Set as default for the FPGA
	board_fpga->default_clock = port_clk125m->access;

	pinsattr = ListPin_MakeListAttr("LOC = L16", "IOSTANDARD = LVCMOS33", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_clk125m, pinsattr);

	// The 4 switches (note: active high)

	netlist_port_t* port_sw4 = Netlist_Comp_AddPortAccess_WireIn(comp, namealloc("zybo_sw4"), 4);

	// Switches: here processed from 3 downto 0
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = T16", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = W13", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = P15", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = G15", "IOSTANDARD = LVCMOS33", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_sw4, pinsattr);

	// The 4 push-buttons (note: active high)

	netlist_port_t* port_btn4 = Netlist_Comp_AddPortAccess_WireIn(comp, namealloc("zybo_btn4"), 4);

	// Push-buttons: here processed from 3 downto 0
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = Y16", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = V16", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = P16", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = R18", "IOSTANDARD = LVCMOS33", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_btn4, pinsattr);

	// The 4 LEDs (note: active high)

	netlist_port_t* port_led4 = Netlist_Comp_AddPortAccess_WireOut(comp, namealloc("zybo_led4"), 4);

	// LEDs: here processed from 3 downto 0
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = D18", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = G14", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = M15", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = M14", "IOSTANDARD = LVCMOS33", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_led4, pinsattr);

	#if 0  // The Pmod connectors
	// FIXME Here declared only input but the user WILL want to change that

	// Pmod JA: XADC
	netlist_port_t* port_pmod_a = Netlist_Comp_AddPortAccess_WireIn(comp, namealloc("zybo_pmod_a"), 8);

	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = J14", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = J16", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = L15", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = N16", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = K14", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = K16", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = L14", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = N15", "IOSTANDARD = LVCMOS33", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_pmod_a, pinsattr);

	// Pmod JE: Standard
	netlist_port_t* port_pmod_e = Netlist_Comp_AddPortAccess_WireIn(comp, namealloc("zybo_pmod_e"), 8);

	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = Y17", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = T17", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = U17", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = V13", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = H15", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = J15", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = W16", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = V12", "IOSTANDARD = LVCMOS33", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_pmod_e, pinsattr);
	#endif

	#if 1  // A UART interface that uses Pmod E

	// Pins on the left of the connector are used: pin 1 is Rx, pin 7 is Tx

	// Rx
	netlist_access_t* access_uart_je_rx = Netlist_Comp_AddAccess_Uart_Rx(comp, namealloc("xupv5_uart1_rx"));
	netlist_access_uart_side_t* uart_je_rx_data = access_uart_je_rx->data;
	uart_je_rx_data->cfg.databits_nb = 8;
	uart_je_rx_data->cfg.baudrate = 115200;
	uart_je_rx_data->cfg.parity = false;
	// Set as default communication channel
	board_fpga->default_stdin = access_uart_je_rx;

	pinsattr = ListPin_MakeListAttr("LOC = V12", "IOSTANDARD = LVCMOS33", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, uart_je_rx_data->port_uart, pinsattr);

	// Tx
	netlist_access_t* access_uart_je_tx = Netlist_Comp_AddAccess_Uart_Tx(comp, namealloc("xupv5_uart1_tx"));
	netlist_access_uart_side_t* uart_je_tx_data = access_uart_je_tx->data;
	uart_je_tx_data->cfg.databits_nb = 8;
	uart_je_tx_data->cfg.baudrate = 115200;
	uart_je_tx_data->cfg.parity = false;
	// Set as default communication channel
	board_fpga->default_stdout = access_uart_je_tx;

	pinsattr = ListPin_MakeListAttr("LOC = V13", "IOSTANDARD = LVCMOS33", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, uart_je_tx_data->port_uart, pinsattr);

	#endif

	/* Missing board features

	- VGA, HDMI
	- PMOD connectors: B, C, D (high-speed without resistor), F (MIO)
	- Stuff via EMIO: UART, USB, Ethernet etc?

	*/

	// Finally, return the board
	return board;
}

board_t* Xilinx_BuildBoard_ZedBoard() {
	board_t* board = Board_New();

	board->name = namealloc("zedboard");
	board->description = stralloc("ZedBoard Zynq-7000 development board. The FPGA is xc7z020 speed grade 1 (techno artix-7).");

	// Add a board_fpga_t structure
	board_fpga_t* board_fpga = Board_FPGA_New();
	board_fpga->name = namealloc("fpga");
	board_fpga->model = Techno_GetFPGA(namealloc("xc7z020"));
	assert(board_fpga->model!=NULL);
	board_fpga->speed = Techno_FPGA_GetSpeed(board_fpga->model, namealloc("1"));
	assert(board_fpga->speed!=NULL);
	board_fpga->package = Techno_FPGA_GetPkg(board_fpga->model, namealloc("clg484"));
	assert(board_fpga->package!=NULL);

	board_fpga->board = board;
	avl_pp_add_overwrite(&board->fpgas, board_fpga->name, board_fpga);

	// The JTAG id
	board_fpga->jtag_id = 2;
	board_fpga->xc3sprog_cable = stralloc("jtaghs1");

	// Add board connectivity

	netlist_comp_t* comp = board_fpga->connect = Netlist_Comp_Top_New(board_fpga->name);
	chain_list* pinsattr;

	// The 100 MHz clock USER_CLOCK (part IC17 on the board)

	netlist_port_t* port_clk100m = Netlist_Comp_AddPortAccess_Clock(comp, namealloc("zedboard_clock100"));
	Netlist_Access_Clock_SetFrequency(port_clk100m->access, 100e6);
	// Set as default for the FPGA
	board_fpga->default_clock = port_clk100m->access;

	pinsattr = ListPin_MakeListAttr("LOC = Y9", "IOSTANDARD = LVCMOS33", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_clk100m, pinsattr);

	// The 8 user LEDs (note: active high)

	netlist_port_t* port_led8 = Netlist_Comp_AddPortAccess_WireOut(comp, namealloc("zedboard_led8"), 8);

	// LEDs: here processed from 7 downto 0
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = U14", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = U19", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = W22", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = V22", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = U21", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = U22", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = T21", "IOSTANDARD = LVCMOS33", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = T22", "IOSTANDARD = LVCMOS33", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_led8, pinsattr);

	// The 8 user switches (note: active high)

	netlist_port_t* port_sw8 = Netlist_Comp_AddPortAccess_WireIn(comp, namealloc("zedboard_sw8"), 8);

	// Switches: here processed from 7 downto 0
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = M15", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = H17", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = H18", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = H19", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = F21", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = H22", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = G22", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = F22", "IOSTANDARD = LVCMOS18", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_sw8, pinsattr);

	// The 5 user push buttons (note: active high)

	netlist_port_t* port_btn5 = Netlist_Comp_AddPortAccess_WireIn(comp, namealloc("zedboard_btn5"), 5);

	// Buttons: here processed in this order: north, east, south, west, center
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = T18", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = R18", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = R16", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = N15", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = P16", "IOSTANDARD = LVCMOS18", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_btn5, pinsattr);

	// FIXME WARNING non-fixed voltages
	// Banks 34 and 35 are powered from an adjustable voltage rail
	// The default is 1.8V but can be changed to 2.5V
	// This impacts push buttons and the 8 switches

	// FIXME A general board config for IOSTANDARD per-bank value should be used

	// Finally, return the board
	return board;
}

board_t* Xilinx_BuildBoard_Zc706() {
	board_t* board = Board_New();

	board->name = namealloc("zc706");
	board->description = stralloc("Xilinx Zynq-7000 All Programmable SoC ZC706 Evaluation Kit. The FPGA is XC7Z045T-2FFG900C.");

	// Add a board_fpga_t structure
	board_fpga_t* board_fpga = Board_FPGA_New();
	board_fpga->name = namealloc("fpga");
	board_fpga->model = Techno_GetFPGA(namealloc("xc7z045"));
	assert(board_fpga->model!=NULL);
	board_fpga->speed = Techno_FPGA_GetSpeed(board_fpga->model, namealloc("2"));
	assert(board_fpga->speed!=NULL);
	board_fpga->package = Techno_FPGA_GetPkg(board_fpga->model, namealloc("ffg900"));
	assert(board_fpga->package!=NULL);

	board_fpga->board = board;
	avl_pp_add_overwrite(&board->fpgas, board_fpga->name, board_fpga);

	// The JTAG id (assuming the first is 1)
	board_fpga->jtag_id = 2;
	board_fpga->xc3sprog_cable = stralloc("jtaghs2");

	// Add board connectivity

	netlist_comp_t* comp = board_fpga->connect = Netlist_Comp_Top_New(board_fpga->name);
	chain_list* pinsattr;

	// The 200 MHz differential clock SYSCLK (part U64 on the board)

	netlist_access_t* access_sysclk200 = Netlist_Comp_AddAccess_DiffClock(comp, namealloc("zc706_sysclk200"));
	netlist_access_diffclock_t* access_sysclk200_data = access_sysclk200->data;
	Netlist_Access_DiffClock_SetFrequency(access_sysclk200, 200e6);
	// Set as default for the FPGA
	board_fpga->default_clock = access_sysclk200;

	pinsattr = ListPin_MakeListAttr("LOC = H9", "IOSTANDARD = LVDS", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_sysclk200_data->port_p, pinsattr);
	pinsattr = ListPin_MakeListAttr("LOC = G9", "IOSTANDARD = LVDS", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_sysclk200_data->port_n, pinsattr);

	// The programmable differential clock USRCLK (initial frequency 156.25 MHz) (part U37 on the board)

	netlist_access_t* access_usrclk156 = Netlist_Comp_AddAccess_DiffClock(comp, namealloc("zc706_usrclk156"));
	netlist_access_diffclock_t* access_usrclk156_data = access_usrclk156->data;
	Netlist_Access_DiffClock_SetFrequency(access_usrclk156, 156.250e6);

	pinsattr = ListPin_MakeListAttr("LOC = AF14", "IOSTANDARD = LVDS_25", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_usrclk156_data->port_p, pinsattr);
	pinsattr = ListPin_MakeListAttr("LOC = AG14", "IOSTANDARD = LVDS_25", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_usrclk156_data->port_n, pinsattr);

	// The differential clock USER_SMA_CLOCK (connectors J67 and J68 on the board)

	netlist_access_t* access_user_sma_clock = Netlist_Comp_AddAccess_DiffClock(comp, namealloc("zc706_user_sma_clock"));
	netlist_access_diffclock_t* access_user_sma_clock_data = access_user_sma_clock->data;

	pinsattr = ListPin_MakeListAttr("LOC = AD18", "IOSTANDARD = LVDS_25", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_user_sma_clock_data->port_p, pinsattr);
	pinsattr = ListPin_MakeListAttr("LOC = AD19", "IOSTANDARD = LVDS_25", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_user_sma_clock_data->port_n, pinsattr);

	// The differential clock SMA_MGT_REFCLK (GTX SMA Clock) (connectors J36 and J31 on the board)

	netlist_access_t* access_sma_mgt_refclk = Netlist_Comp_AddAccess_DiffClock(comp, namealloc("zc706_sma_mgt_refclk"));
	netlist_access_diffclock_t* access_sma_mgt_refclk_data = access_sma_mgt_refclk->data;

	pinsattr = ListPin_MakeListAttr("LOC = W8", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_sma_mgt_refclk_data->port_p, pinsattr);
	pinsattr = ListPin_MakeListAttr("LOC = W7", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_sma_mgt_refclk_data->port_n, pinsattr);

	// FIXME Missing Jitter attenuated clock -> how does this work?

	// The PL_CPU_RESET pushbutton (part SW13 on the board)

	netlist_port_t* port_cpureset = Netlist_Comp_AddPortAccess_Reset(comp, namealloc("zc706_pl_cpu_reset"));
	Netlist_Access_Reset_SetActiveState(port_cpureset->access, '1');
	// Set as default for the FPGA
	board_fpga->default_reset = port_cpureset->access;

	pinsattr = ListPin_MakeListAttr("LOC = A8", "IOSTANDARD = LVCMOS15", "TIG", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_cpureset, pinsattr);

	// The other user pushbuttons left, center, right (note: active high) (parts SW7, SW9, SW8 on the board)
	// Order from 2 downto 0: left, center, right

	netlist_port_t* port_pushbuttons = Netlist_Comp_AddPortAccess_WireIn(comp, namealloc("zc706_pushbuttons"), 3);

	// Here processed in order 2 downto 0 (respectively named left, center, right on the board)
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AK25", "IOSTANDARD = LVCMOS25", "TIG", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = K15", "IOSTANDARD = LVCMOS15", "TIG", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = R27", "IOSTANDARD = LVCMOS25", "TIG", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_pushbuttons, pinsattr);

	// The GPIO DIP Switches (note: active high) (part SW12 on the board)

	netlist_port_t* port_dipswitch = Netlist_Comp_AddPortAccess_WireIn(comp, namealloc("zc706_dipswitch"), 4);

	// DIP Switches: here processed 3 downto 0 (respectively named 4 downto 1 on the board)
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AJ13", "IOSTANDARD = LVCMOS25", "TIG", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AC17", "IOSTANDARD = LVCMOS25", "TIG", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AC16", "IOSTANDARD = LVCMOS25", "TIG", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AB17", "IOSTANDARD = LVCMOS25", "TIG", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_dipswitch, pinsattr);

	// The LED_0 (part DS35 on the board)

	netlist_port_t* port_led_0 = Netlist_Comp_AddPortAccess_WireOut(comp, namealloc("zc706_led_0"), 1);
	pinsattr = ListPin_MakeListAttr("LOC = A17", "IOSTANDARD = LVCMOS15", "TIG", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_led_0, pinsattr);

	// The LEDs left, center, right (parts DS8, DS9, DS10 on the board)

	netlist_port_t* port_leds = Netlist_Comp_AddPortAccess_WireOut(comp, namealloc("zc706_leds"), 3);

	// Here processed in order 2 downto 0 (respectively left, center, right)
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = Y21", "IOSTANDARD = LVCMOS25", "TIG", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = G2", "IOSTANDARD = LVCMOS15", "TIG", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = W21", "IOSTANDARD = LVCMOS25", "TIG", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_leds, pinsattr);

	// The cooling fan (connector J61 on the board)

	// The fan PWM output (the fan turns on when output is 1)
	netlist_port_t* port_fan_pwm = Netlist_Comp_AddPortAccess_WireOut(comp, namealloc("zc706_fan_pwm"), 1);
	pinsattr = ListPin_MakeListAttr("LOC = AB19", "IOSTANDARD = LVCMOS25", "TIG", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_fan_pwm, pinsattr);

	// The fan TACH input
	netlist_port_t* port_fan_tach = Netlist_Comp_AddPortAccess_WireIn(comp, namealloc("zc706_fan_tach"), 1);
	pinsattr = ListPin_MakeListAttr("LOC = AA19", "IOSTANDARD = LVCMOS25", "TIG", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_fan_tach, pinsattr);

	// FIXME  Missing board features: HDMI output

	// Finally, return the board
	return board;
}

board_t* Xilinx_BuildBoard_Vc709() {
	board_t* board = Board_New();

	board->name = namealloc("vc709");
	board->description = stralloc("VC709 evaluation board \"Connectivity Kit\". The FPGA is XC7VX690T-2FFG1761C.");

	// Add a board_fpga_t structure
	board_fpga_t* board_fpga = Board_FPGA_New();
	board_fpga->name = namealloc("fpga");
	board_fpga->model = Techno_GetFPGA(namealloc("xc7vx690t"));
	assert(board_fpga->model!=NULL);
	board_fpga->speed = Techno_FPGA_GetSpeed(board_fpga->model, namealloc("2"));
	assert(board_fpga->speed!=NULL);
	board_fpga->package = Techno_FPGA_GetPkg(board_fpga->model, namealloc("ffg1761"));
	assert(board_fpga->package!=NULL);

	board_fpga->board = board;
	avl_pp_add_overwrite(&board->fpgas, board_fpga->name, board_fpga);

	// The JTAG id (assuming the first is 1)
	board_fpga->jtag_id = 1;
	board_fpga->xc3sprog_cable = stralloc("jtaghs1_fast");

	// Add board connectivity

	netlist_comp_t* comp = board_fpga->connect = Netlist_Comp_Top_New(board_fpga->name);
	chain_list* pinsattr;

	// The 200 MHz differential clock SYSCLK (part U51 on the board)

	netlist_access_t* access_sysclk200 = Netlist_Comp_AddAccess_DiffClock(comp, namealloc("vc709_sysclk200"));
	netlist_access_diffclock_t* access_sysclk200_data = access_sysclk200->data;
	Netlist_Access_DiffClock_SetFrequency(access_sysclk200, 200e6);
	// Set as default for the FPGA
	board_fpga->default_clock = access_sysclk200;

	pinsattr = ListPin_MakeListAttr("LOC = H19", "IOSTANDARD = DIFF_SSTL15", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_sysclk200_data->port_p, pinsattr);
	pinsattr = ListPin_MakeListAttr("LOC = G18", "IOSTANDARD = DIFF_SSTL15", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_sysclk200_data->port_n, pinsattr);

	// The 233 MHz differential clock SYSCLK_233 (part U13 on the board)

	netlist_access_t* access_sysclk233 = Netlist_Comp_AddAccess_DiffClock(comp, namealloc("vc709_sysclk233"));
	netlist_access_diffclock_t* access_sysclk233_data = access_sysclk233->data;
	Netlist_Access_DiffClock_SetFrequency(access_sysclk233, 233.3333e6);

	pinsattr = ListPin_MakeListAttr("LOC = AY18", "IOSTANDARD = DIFF_SSTL15", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_sysclk233_data->port_p, pinsattr);
	pinsattr = ListPin_MakeListAttr("LOC = AY17", "IOSTANDARD = DIFF_SSTL15", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_sysclk233_data->port_n, pinsattr);

	// The programmable differential clock USER_CLOCK (initial frequency 156.25 MHz) (part U34 on the board)

	netlist_access_t* access_userclock = Netlist_Comp_AddAccess_DiffClock(comp, namealloc("vc709_usrclk"));
	netlist_access_diffclock_t* access_userclock_data = access_userclock->data;
	Netlist_Access_DiffClock_SetFrequency(access_userclock, 156.25e6);

	pinsattr = ListPin_MakeListAttr("LOC = AK34", "IOSTANDARD = LVDS", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_userclock_data->port_p, pinsattr);
	pinsattr = ListPin_MakeListAttr("LOC = AL34", "IOSTANDARD = LVDS", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_userclock_data->port_n, pinsattr);

	// The 80 MHz external master clock EMCCLK (part U40 on the board)
	// Note from XAPP586 (v1.2): This clock is internally routed to the CCLK FPGA pin
	//   This CCLK pin seems to be used to read bitstream from external SPI Flash memory
	//   When not using the EMC, there is an internal low-frequency oscillator
	// WARNING It seems the EMC pin is not intended to be a proper clock for an FPGA design
	//   By default, Vivado emits an error.
	//   It can be demoted to a warning with this TCL command (use before command place_design):
	//     set_property CLOCK_DEDICATED_ROUTE FALSE [get_nets clock_IBUF]

	netlist_port_t* port_emcclk80 = Netlist_Comp_AddPortAccess_Clock(comp, namealloc("vc709_emcclk80"));
	Netlist_Access_Clock_SetFrequency(port_emcclk80->access, 80e6);

	pinsattr = ListPin_MakeListAttr("LOC = AP37", "IOSTANDARD = LVCMOS18", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_emcclk80, pinsattr);

	// The CPU_RESET pushbutton (part SW8 on the board)

	netlist_port_t* port_cpureset = Netlist_Comp_AddPortAccess_Reset(comp, namealloc("vc709_cpureset"));
	Netlist_Access_Reset_SetActiveState(port_cpureset->access, '1');
	// Set as default for the FPGA
	board_fpga->default_reset = port_cpureset->access;

	pinsattr = ListPin_MakeListAttr("LOC = AV40", "IOSTANDARD = LVCMOS18", "TIG", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_cpureset, pinsattr);

	// The UART interface (connector J17 on the board)

	// Rx
	netlist_access_t* access_uart1rx = Netlist_Comp_AddAccess_Uart_Rx(comp, namealloc("vc709_uart_rx"));
	netlist_access_uart_side_t* access_uart1rx_data = access_uart1rx->data;
	access_uart1rx_data->cfg.databits_nb = 8;
	access_uart1rx_data->cfg.baudrate = 115200;
	access_uart1rx_data->cfg.parity = false;
	// Set as default communication channel
	board_fpga->default_stdin = access_uart1rx;

	pinsattr = ListPin_MakeListAttr("LOC = AU33", "IOSTANDARD = LVCMOS18", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_uart1rx_data->port_uart, pinsattr);

	// Tx
	netlist_access_t* access_uart1tx = Netlist_Comp_AddAccess_Uart_Tx(comp, namealloc("vc709_uart_tx"));
	netlist_access_uart_side_t* access_uart1tx_data = access_uart1tx->data;
	access_uart1tx_data->cfg.databits_nb = 8;
	access_uart1tx_data->cfg.baudrate = 115200;
	access_uart1tx_data->cfg.parity = false;
	// Set as default communication channel
	board_fpga->default_stdout = access_uart1tx;

	pinsattr = ListPin_MakeListAttr("LOC = AU36", "IOSTANDARD = LVCMOS18", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, access_uart1tx_data->port_uart, pinsattr);

	// The GPIO DIP Switches (note: active high)

	netlist_port_t* port_dipsw = Netlist_Comp_AddPortAccess_WireIn(comp, namealloc("vc709_dipsw"), 8);

	// DIP Switches: here processed from 0 to 7 (respectively named 1 to 8 on the board)
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AV30", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AY33", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = BA31", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = BA32", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AW30", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AY30", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = BA30", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = BB31", "IOSTANDARD = LVCMOS18", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_dipsw, reverse(pinsattr));

	// The LEDs 8 bits (note: active high)

	netlist_port_t* port_leds8 = Netlist_Comp_AddPortAccess_WireOut(comp, namealloc("vc709_leds8"), 8);

	// LEDs: here processed from 7 downto 0
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AU39", "IOSTANDARD = LVCMOS18", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AP42", "IOSTANDARD = LVCMOS18", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AP41", "IOSTANDARD = LVCMOS18", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AR35", "IOSTANDARD = LVCMOS18", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AT37", "IOSTANDARD = LVCMOS18", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AR37", "IOSTANDARD = LVCMOS18", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AN39", "IOSTANDARD = LVCMOS18", "SLEW = SLOW", "DRIVE = 2", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AM39", "IOSTANDARD = LVCMOS18", "SLEW = SLOW", "DRIVE = 2", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_leds8, pinsattr);

	// The directional pushbuttons south, north etc (note: active high)

	netlist_port_t* port_swpos = Netlist_Comp_AddPortAccess_WireIn(comp, namealloc("vc709_swpos"), 5);

	// Here processed in this order: north, east, south, west, center (respectively named SW3, SW4, SW5, SW7, SW6 on the board)
	pinsattr = NULL;
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AR40", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AU38", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AP40", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AW40", "IOSTANDARD = LVCMOS18", NULL);
	pinsattr = ListPin_AddListAttr(pinsattr, "LOC = AV39", "IOSTANDARD = LVCMOS18", NULL);

	avl_pp_add_overwrite(&board_fpga->port2pin, port_swpos, pinsattr);

	// The fan PWM output

	netlist_port_t* port_fan_pwm = Netlist_Comp_AddPortAccess_WireOut(comp, namealloc("vc709_fan_pwm"), 1);
	pinsattr = ListPin_MakeListAttr("LOC = BA37", "IOSTANDARD = LVCMOS18", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_fan_pwm, pinsattr);

	// The fan TACH input

	netlist_port_t* port_fan_tach = Netlist_Comp_AddPortAccess_WireIn(comp, namealloc("vc709_fan_tach"), 1);
	pinsattr = ListPin_MakeListAttr("LOC = BB37", "IOSTANDARD = LVCMOS18", NULL);
	avl_pp_add_overwrite(&board_fpga->port2pin, port_fan_tach, pinsattr);

	// Extra data for the FPGA
	xilinx_board_data_t* fpga_techdata = Xilinx_BoardData_New();
	board_fpga->techdata = fpga_techdata;

	// The configuration voltage
	// More info: see configuration user guide ug470, and the board user guide ug887
	// For this FPGA, all relevant banks are 1.8V
	fpga_techdata->cfgbvs_en = true;
	fpga_techdata->param_cfgbvs = "GND";
	fpga_techdata->param_config_voltage = 1.8;

	// Finally, return the board
	return board;
}



//======================================================================
// Reading techno data from JSON files
//======================================================================

// Note: JSON format: http://www.json.org/
// Note: jansson API: http://www.digip.org/jansson/

#include <jansson.h>

// Fix for systems that have jansson 2.4 instead of 2.5+
#ifndef json_array_foreach
#define json_array_foreach(array, index, value) \
	for(index = 0; index < json_array_size(array) && (value = json_array_get(array, index)); index++)
#endif

// Functions to write JSON files

static void fdump_chip(FILE* F, fpga_model_t* chip) {
	fprintf(F, "\"%s\": {\n", chip->name);

	if(chip->description!=NULL) {
		fprintf(F, "	\"desc\": \"%s\"\n", chip->description);
	}

	fprintf(F, "	\"speeds\": [");
	foreach(chip->timings, scan) {
		techno_timing_t* timing = scan->DATA;
		if(scan!=chip->timings) fprintf(F, ", ");
		fprintf(F, "\"%s\"", timing->name);
	}
	fprintf(F, "],\n");

	fprintf(F, "	\"packages\": [");
	foreach(chip->packages, scan) {
		fpga_pkg_model_t* pkg = scan->DATA;
		if(scan!=chip->packages) fprintf(F, ", ");
		fprintf(F, "\"%s\"", pkg->name);
	}
	fprintf(F, "],\n");

	xilinx_res_t* xres = chip->resources;
	fprintf(F, "	\"resources\": {\n");
	fprintf(F, "		\"lut\"    : %u,\n", xres->lut6);
	fprintf(F, "		\"ff\"     : %u,\n", xres->ff);
	fprintf(F, "		\"lutram\" : %u,\n", xres->lutram);
	fprintf(F, "		\"dsp\"    : %u,\n", xres->dsp48e);
	fprintf(F, "		\"bram\"   : %u\n", xres->bram36k);
	fprintf(F, "	}\n");

	fprintf(F, "}\n");
}

void Xilinx_Techno_WriteJSON(plugin_t* plugin) {

	// Read all chips declared by the current plugin
	// Dump their JSON representation in stdout

	avl_pp_foreach(&plugin->fpgas, scan) {
		fpga_model_t* chip = scan->data;
		fdump_chip(stdout, chip);
	}

	// FIXME for debug
	exit(EXIT_SUCCESS);
}

// Functions to read JSON files

static bool parse_json_verbose = false;

static void parse_chip(plugin_t* plugin, fpga_model_t* chip, json_t *json) {
	if(json_is_object(json)==false) {
		printf("Error: Wrong JSON type for chip '%s', techno '%s'\n", chip->name, chip->techno->name);
		exit(EXIT_FAILURE);
	}

	if(parse_json_verbose==true) {
		printf("Info: Parsing chip '%s', 'techno '%s'\n", chip->name, chip->techno->name);
	}

	unsigned index;
	const char *key;
	json_t *json_value;

	// Read the description
	json_t *json_desc = json_object_get(json, "desc");
	if(json_desc!=NULL) {
		if(json_is_string(json_desc)==false) {
			printf("Error: Wrong JSON type for description of chip '%s', techno '%s'\n", chip->name, chip->techno->name);
			exit(EXIT_FAILURE);
		}
		chip->description = stralloc(json_string_value(json_desc));
	}

	// Read the speed grades
	json_t *json_speeds = json_object_get(json, "speeds");
	if(json_speeds==NULL) {
		printf("Error: Missing speed grades for chip '%s', techno '%s'\n", chip->name, chip->techno->name);
		exit(EXIT_FAILURE);
	}
	if(json_is_array(json_speeds)==false) {
		printf("Error: Wrong JSON type for speeds of chip '%s', techno '%s'\n", chip->name, chip->techno->name);
		exit(EXIT_FAILURE);
	}
	json_array_foreach(json_speeds, index, json_value) {
		if(json_is_string(json_value)==false) {
			printf("Error: Wrong JSON type for speed name for chip '%s', techno '%s'\n", chip->name, chip->techno->name);
			exit(EXIT_FAILURE);
		}
		char* name = namealloc(json_string_value(json_value));
		techno_timing_t* timing = Techno_GetSpeed(chip->techno, name);
		if(timing==NULL) {
			printf("Error: Unknown speed grade '%s' for chip '%s', techno '%s'\n", name, chip->name, chip->techno->name);
			exit(EXIT_FAILURE);
		}
		chip->timings = addchain(chip->timings, timing);
	}

	// Read the packages
	json_t *json_pkgs = json_object_get(json, "packages");
	if(json_pkgs==NULL) {
		printf("Error: Missing packages for chip '%s', techno '%s'\n", chip->name, chip->techno->name);
		exit(EXIT_FAILURE);
	}
	if(json_is_array(json_pkgs)==false) {
		printf("Error: Wrong JSON type for packages of chip '%s', techno '%s'\n", chip->name, chip->techno->name);
		exit(EXIT_FAILURE);
	}
	json_array_foreach(json_pkgs, index, json_value) {
		if(json_is_string(json_value)==false) {
			printf("Error: Wrong JSON type for package for chip '%s', techno '%s'\n", chip->name, chip->techno->name);
			exit(EXIT_FAILURE);
		}
		char* name = namealloc(json_string_value(json_value));
		fpga_pkg_model_t* pkg = Techno_GetPackage(chip->techno, name);
		if(pkg==NULL) {
			printf("Error: Unknown package '%s' for chip '%s', techno '%s'\n", name, chip->name, chip->techno->name);
			exit(EXIT_FAILURE);
		}
		chip->packages = addchain(chip->packages, pkg);
	}

	// Read the resources
	json_t *json_resources = json_object_get(json, "resources");
	if(json_resources==NULL) {
		printf("Error: Missing resources for chip '%s', techno '%s'\n", chip->name, chip->techno->name);
		exit(EXIT_FAILURE);
	}
	if(json_is_object(json_resources)==false) {
		printf("Error: Wrong JSON type for resources of chip '%s', techno '%s'\n", chip->name, chip->techno->name);
		exit(EXIT_FAILURE);
	}
	xilinx_res_t* xres = Xilinx_Res_New();
	chip->resources = xres;
	json_object_foreach(json_resources, key, json_value) {
		// All values must be integers
		if(json_is_integer(json_value)==false) {
			printf("Error: Wrong JSON type for resource '%s' for chip '%s', techno '%s'\n", key, chip->name, chip->techno->name);
			exit(EXIT_FAILURE);
		}
		unsigned value_u = json_integer_value(json_value);
		if     (strcmp(key, "lut")==0)   xres->lut6 = value_u;
		else if(strcmp(key, "ff")==0)    xres->ff = value_u;
		else if(strcmp(key, "dsp")==0)   xres->dsp48e = value_u;
		else if(strcmp(key, "bram")==0)  xres->bram36k = value_u;
		else if(strcmp(key, "lutram")==0) xres->lutram = value_u;
		else {
			printf("Error: Unknown resource '%s' for chip '%s', techno '%s'\n", key, chip->name, chip->techno->name);
			exit(EXIT_FAILURE);
		}
	}
}

static void parse_timing(plugin_t* plugin, techno_timing_t* timing, json_t *json) {
	if(json_is_object(json)==false) {
		printf("Error: Wrong JSON type for timing '%s', techno '%s'\n", timing->name, timing->techno->name);
		exit(EXIT_FAILURE);
	}

	if(parse_json_verbose==true) {
		printf("Info: Parsing timing '%s', 'techno '%s'\n", timing->name, timing->techno->name);
	}

	xilinx_timing_t* xtiming = calloc(1, sizeof(*xtiming));
	xtiming->dsp48e.avail = false;
	timing->data = xtiming;

	// Parse all elements of the speed grade
	const char *key;
	json_t *json_value;
	json_object_foreach(json, key, json_value) {

		if(strcmp(key, "desc")==0) {
			if(json_is_string(json_value)==false) {
				printf("Error: Wrong JSON type for description of timing '%s', techno '%s'\n", timing->name, timing->techno->name);
				exit(EXIT_FAILURE);
			}
			timing->description = stralloc(json_string_value(json_value));
			continue;
		}

		else if(strcmp(key, "dsp")==0) {
			if(json_is_object(json_value)==false) {
				printf("Error: Wrong JSON type for element '%s' in timing '%s', techno '%s'\n", key, timing->name, timing->techno->name);
				exit(EXIT_FAILURE);
			}
			xtiming->dsp48e.avail = true;
			// Read all elements
			const char *keydsp;
			json_t *json_valdsp;
			json_object_foreach(json_value, keydsp, json_valdsp) {
				// Here the value can only be a number (a double, in ns)
				if(json_is_number(json_valdsp)==false) {
					printf("Error: Wrong JSON type for timing elements '%s' of timing '%s', techno '%s'\n", keydsp, timing->name, timing->techno->name);
					exit(EXIT_FAILURE);
				}
				double value_dbl = json_number_value(json_valdsp);
				// Parse the different possible values
				if     (strcmp(keydsp, "ab_mul_cout")==0)  xtiming->dsp48e.ab_mul_cout = value_dbl;
				else if(strcmp(keydsp, "ab_p")==0)         xtiming->dsp48e.ab_p = value_dbl;
				else if(strcmp(keydsp, "c_p")==0)          xtiming->dsp48e.c_p = value_dbl;

				else if(strcmp(keydsp, "abCasc_mul_p")==0) xtiming->dsp48e.CascAB_mul_p = value_dbl;
				else if(strcmp(keydsp, "abCasc_p")==0)     xtiming->dsp48e.CascAB_p = value_dbl;
				else if(strcmp(keydsp, "abCasc_abCasc")==0) xtiming->dsp48e.CascAB_CascAB = value_dbl;
				else if(strcmp(keydsp, "abCasc_mul_cCasc")==0) xtiming->dsp48e.CascAB_mul_CascC = value_dbl;
				else if(strcmp(keydsp, "pCasc_p")==0)      xtiming->dsp48e.CascP_p = value_dbl;
				else if(strcmp(keydsp, "pCasc_cCasc")==0)  xtiming->dsp48e.CascP_CascC = value_dbl;

				else if(strcmp(keydsp, "ab_abCasc")==0)    xtiming->dsp48e.ab_CascAB = value_dbl;
				else if(strcmp(keydsp, "ab_mul_cCasc")==0) xtiming->dsp48e.ab_mul_CascC = value_dbl;
				else if(strcmp(keydsp, "ab_cCasc")==0)     xtiming->dsp48e.ab_CascC = value_dbl;
				else if(strcmp(keydsp, "c_cCasc")==0)      xtiming->dsp48e.c_CascC = value_dbl;

				else {
					printf("Error: Unknown JSON key '%s' in dsp timing '%s', techno '%s'\n", keydsp, timing->name, timing->techno->name);
					exit(EXIT_FAILURE);
				}
			}
			continue;
		}

		// Here the value can only be a number (a double, in ns)
		if(json_is_number(json_value)==false) {
			printf("Error: Wrong JSON type for timing elements '%s' of timing '%s', techno '%s'\n", key, timing->name, timing->techno->name);
			exit(EXIT_FAILURE);
		}
		double value_dbl = json_number_value(json_value);

		// Parse the different possible values

		if     (strcmp(key, "lut_delay")==0)          xtiming->lut6_delay = value_dbl;
		else if(strcmp(key, "mux_delay")==0)          xtiming->mux_delay = value_dbl;
		else if(strcmp(key, "net_delay")==0)          xtiming->wire_delay = value_dbl;

		else if(strcmp(key, "carry_mux_s_cout")==0)   xtiming->CARRY_S_delay = value_dbl;
		else if(strcmp(key, "carry_cin_cout")==0)     xtiming->CARRY_CI_delay = value_dbl;
		else if(strcmp(key, "carry_cin_xorcy")==0)    xtiming->XORCY_CI_delay = value_dbl;

		else if(strcmp(key, "ff_bef_wd")==0)          xtiming->FF_bef_wd = value_dbl;
		else if(strcmp(key, "ff_bef_ce")==0)          xtiming->FF_bef_ce = value_dbl;
		else if(strcmp(key, "ff_aft_rd")==0 )         xtiming->FF_aft_rd = value_dbl;

		else if(strcmp(key, "lutram_bef_wd")==0)      xtiming->lutram_bef_wd = value_dbl;
		else if(strcmp(key, "lutram_bef_wa")==0)      xtiming->lutram_bef_wa = value_dbl;
		else if(strcmp(key, "lutram_bef_we")==0 )     xtiming->lutram_bef_we = value_dbl;
		else if(strcmp(key, "lutram_aft")==0 )        xtiming->lutram_aft = value_dbl;

		else if(strcmp(key, "bram36k_bef_wd")==0 )    xtiming->bram36k_bef_wd = value_dbl;
		else if(strcmp(key, "bram36k_bef_wa")==0 )    xtiming->bram36k_bef_wa = value_dbl;
		else if(strcmp(key, "bram36k_bef_we")==0 )    xtiming->bram36k_bef_we = value_dbl;
		else if(strcmp(key, "bram36k_bef_ra")==0 )    xtiming->bram36k_bef_ra = value_dbl;
		else if(strcmp(key, "bram36k_bef_re")==0 )    xtiming->bram36k_bef_re = value_dbl;
		else if(strcmp(key, "bram36k_aft_read")==0 )      xtiming->bram36k_aft_read = value_dbl;
		else if(strcmp(key, "bram36k_aft_read_casc")==0 ) xtiming->bram36k_aft_read_casc = value_dbl;

		else {
			printf("Error: Unknown JSON key '%s' in timing '%s', techno '%s'\n", key, timing->name, timing->techno->name);
			exit(EXIT_FAILURE);
		}

	}  // Scan all objects

}  // Parse timing

static void parse_techno(plugin_t* plugin, techno_t* techno, json_t *json) {
	if(json_is_object(json)==false) {
		printf("Error: Wrong JSON type for techno '%s'\n", techno->name);
		exit(EXIT_FAILURE);
	}

	if(parse_json_verbose==true) {
		printf("Info: Parsing techno '%s'\n", techno->name);
	}

	// Parse all elements of the techno
	json_t *json_value;

	// The description
	json_value = json_object_get(json, "desc");
	if(json_value!=NULL) {
		if(json_is_string(json_value)==false) {
			printf("Error: Wrong JSON type for description of techno '%s'\n", techno->name);
			exit(EXIT_FAILURE);
		}
		techno->description = stralloc(json_string_value(json_value));
	}

	// The speeds
	json_value = json_object_get(json, "speeds");
	if(json_value!=NULL) {
		if(json_is_object(json_value)==false) {
			printf("Error: Wrong JSON type for speeds of techno '%s'\n", techno->name);
			exit(EXIT_FAILURE);
		}
		const char *key;
		json_t *json_timing;
		json_object_foreach(json_value, key, json_timing) {
			techno_timing_t* timing = Techno_Timing_New();
			timing->name = namealloc(key);
			Xilinx_Techno_LinkTiming(techno, timing);
			parse_timing(plugin, timing, json_timing);
		}
	}

	// The packages
	json_value = json_object_get(json, "packages");
	if(json_value!=NULL) {
		if(json_is_object(json_value)==false) {
			printf("Error: Wrong JSON type for packages of techno '%s'\n", techno->name);
			exit(EXIT_FAILURE);
		}
		const char *key;
		json_t *json_pkg;
		json_object_foreach(json_value, key, json_pkg) {
			fpga_pkg_model_t* pkg = FPGA_PkgModel_New();
			pkg->name = namealloc(key);

			if(parse_json_verbose==true) {
				printf("Info: Parsing package '%s' of techno '%s'\n", pkg->name, techno->name);
			}

			avl_pp_add_overwrite(&techno->packages, pkg->name, pkg);
			if(json_is_string(json_pkg)==false) {
				printf("Error: Wrong JSON type for package '%s' of techno '%s'\n", pkg->name, techno->name);
				exit(EXIT_FAILURE);
			}
			pkg->description = stralloc(json_string_value(json_pkg));
		}
	}

	// Set all callback functions
	Xilinx_Techno_SetCB(techno);

	// Set appropriate backend control callbacks
	// Note: by default there is no callback set
	if(strcmp(techno->name, "virtex-5")==0 ||
	   strcmp(techno->name, "virtex-7")==0
	) {
		XST_Techno_SetCB(techno);
	}
	if(strcmp(techno->name, "artix-7")==0 ||
	   strcmp(techno->name, "kintex-7")==0
	) {
		Vivado_Techno_SetCB(techno);
	}

	// FIXME here we assume there is no fail
	Plugin_DeclTechno(plugin, techno);

	// The chip references
	json_value = json_object_get(json, "chips");
	if(json_value!=NULL) {
		if(json_is_object(json_value)==false) {
			printf("Error: Wrong JSON type for packages of techno '%s'\n", techno->name);
			exit(EXIT_FAILURE);
		}
		const char *key;
		json_t *json_chip;
		json_object_foreach(json_value, key, json_chip) {
			fpga_model_t* chip = FPGA_Model_New();
			chip->name = namealloc(key);
			chip->techno = techno;
			parse_chip(plugin, chip, json_chip);
			// FIXME here we assume there is no fail
			Plugin_DeclFPGA(plugin, chip);
		}
	}
}

// Main function
void Xilinx_Techno_ReadJSON(plugin_t* plugin) {

	char* path = GetExePath_CutBin();
	char buffer[strlen(path)+40];
	sprintf(buffer, "%s/share/augh/xilinx/technos.json", path);

	if(parse_json_verbose==true) {
		printf("Info: Reading JSON file: %s\n", buffer);
	}

	FILE* F = fopen(buffer, "rb");
	if(F==NULL) {
		fprintf(stderr, "Error: Couldn't open the file %s\n", buffer);
		exit(EXIT_FAILURE);
	}

	json_error_t json_error;
	json_t* json_root = json_loadf(F, 0, &json_error);

	fclose(F);

	if(json_root==NULL) {
		fprintf(stderr, "JSON Error: line %d, message: %s\n", json_error.line, json_error.text);
		exit(EXIT_FAILURE);
	}

	// Remove comments
	void remove_comments(json_t* json) {
		if(json_is_object(json)==true) {
			json_object_del(json, "#");
			const char *key;
			json_t *json_value;
			json_object_foreach(json, key, json_value) remove_comments(json_value);
		}
		else if(json_is_array(json)==true) {
			size_t index;
			json_t *json_value;
			json_array_foreach(json, index, json_value) remove_comments(json_value);
		}
	}
	remove_comments(json_root);

	// Read the JSON data tree

	const char *key;
	json_t *json_value;
	json_object_foreach(json_root, key, json_value) {
		techno_t* techno = Techno_New();
		techno->name = namealloc(key);
		parse_techno(plugin, techno, json_value);
	}

	// Clean
	json_decref(json_root);
}


